/*
    ,--.                     ,--.     ,--.  ,--.
  ,-'  '-.,--.--.,--,--.,---.|  |,-.,-'  '-.`--' ,---. ,--,--,      Copyright 2018
  '-.  .-'|  .--' ,-.  | .--'|     /'-.  .-',--.| .-. ||      \   Tracktion Software
    |  |  |  |  \ '-'  \ `--.|  \  \  |  |  |  |' '-' '|  ||  |       Corporation
    `---' `--'   `--`--'`---'`--'`--' `---' `--' `---' `--''--'    www.tracktion.com

    Tracktion Engine uses a GPL/commercial licence - see LICENCE.md for details.
*/

namespace tracktion_engine
{

/**
    Adds audio and MIDI clicks to the input buffers.
*/
class ClickNode final   : public tracktion_graph::Node
{
public:
    ClickNode (Edit&, int numAudioChannels, bool generateMidi, tracktion_graph::PlayHead&);

    std::vector<Node*> getDirectInputNodes() override;
    tracktion_graph::NodeProperties getNodeProperties() override;
    void prepareToPlay (const tracktion_graph::PlaybackInitialisationInfo&) override;
    bool isReadyToProcess() override;
    void process (ProcessContext&) override;

private:
    //==============================================================================
    Edit& edit;
    tracktion_graph::PlayHead& playHead;
    ClickGenerator clickGenerator;
    const int numChannels;
    const bool generateMidi;
    double sampleRate = 44100.0;
};

} // namespace tracktion_engine
