/*
    ,--.                     ,--.     ,--.  ,--.
  ,-'  '-.,--.--.,--,--.,---.|  |,-.,-'  '-.`--' ,---. ,--,--,      Copyright 2018
  '-.  .-'|  .--' ,-.  | .--'|     /'-.  .-',--.| .-. ||      \   Tracktion Software
    |  |  |  |  \ '-'  \ `--.|  \  \  |  |  |  |' '-' '|  ||  |       Corporation
    `---' `--'   `--`--'`---'`--'`--' `---' `--' `---' `--''--'    www.tracktion.com

    Tracktion Engine uses a GPL/commercial licence - see LICENCE.md for details.
*/

namespace tracktion_engine
{

//==============================================================================
//==============================================================================
/**
    The return node hooks into the input device and fills the insert's return
    buffer with data from the input.
*/
class InsertReturnNode final    : public tracktion_graph::Node
{
public:
    InsertReturnNode (InsertPlugin&, std::unique_ptr<tracktion_graph::Node>);

    InsertPlugin& getInsert() const     { return owner; }

    //==============================================================================
    tracktion_graph::NodeProperties getNodeProperties() override;
    std::vector<Node*> getDirectInputNodes() override;
    void prepareToPlay (const tracktion_graph::PlaybackInitialisationInfo&) override;
    bool isReadyToProcess() override;
    void process (ProcessContext&) override;

private:
    //==============================================================================
    InsertPlugin& owner;
    Plugin::Ptr plugin;
    std::unique_ptr<tracktion_graph::Node> input;
    MidiMessageArray midiScratch;
};

} // namespace tracktion_engine
