/*
    ,--.                     ,--.     ,--.  ,--.
  ,-'  '-.,--.--.,--,--.,---.|  |,-.,-'  '-.`--' ,---. ,--,--,      Copyright 2018
  '-.  .-'|  .--' ,-.  | .--'|     /'-.  .-',--.| .-. ||      \   Tracktion Software
    |  |  |  |  \ '-'  \ `--.|  \  \  |  |  |  |' '-' '|  ||  |       Corporation
    `---' `--'   `--`--'`---'`--'`--' `---' `--' `---' `--''--'    www.tracktion.com

    Tracktion Engine uses a GPL/commercial licence - see LICENCE.md for details.
*/

namespace tracktion_engine
{

/**
    A Node that takes MIDI from the output of a track and sends it to its corresponding InputDevice.
*/
class TrackMidiInputDeviceNode final    : public tracktion_graph::Node
{
public:
    TrackMidiInputDeviceNode (MidiInputDevice&, std::unique_ptr<Node>);

    std::vector<Node*> getDirectInputNodes() override;
    tracktion_graph::NodeProperties getNodeProperties() override;
    void prepareToPlay (const tracktion_graph::PlaybackInitialisationInfo&) override;
    bool isReadyToProcess() override;
    void process (ProcessContext&) override;

private:
    //==============================================================================
    MidiInputDevice& midiInputDevice;
    std::unique_ptr<Node> input;
    double offsetSeconds = 0.0;
    const bool copyInputsToOutputs = false;
};

} // namespace tracktion_engine
